; #########################################################################

.data
MainHDC dd 0
OpenDC dd 0

PixFrm PIXELFORMATDESCRIPTOR <>


Position1 dd 0.0,0.0,-5.0,2.0,0.0,0.0,0.0

dFloat0		dd		0.0
dFloat1		dd		1.0
dva		dd	2.0

ObjectRadius	dd	0.8,0.4,0.3
RotationAngles	dd	1.0,0.5,0.8
RotationSpeed	dd	1.0,0.5,0.8
LightPosition	dd -1.0,1.0,2.0,1.0

Float45 dq 45.0
Float3 dq 3.0
Float9 dq 9.0
Float1 dq 1.0

.code
ResizeObject PROTO :DWORD,:DWORD
DrawScene PROTO 
Init PROTO :DWORD
CreateObjects		PROTO	:DWORD,:DWORD
Ellipsoide	PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD 
Put2Scene		PROTO	:DWORD,:DWORD
Rotate		PROTO    :DWORD,:DWORD,:DWORD,:DWORD
CreateLight		PROTO
; ######################################################################### 

ResizeObject PROC ParentW:DWORD,ParentH:DWORD
invoke glViewport,0,0,ParentW,ParentH
invoke glMatrixMode,GL_PROJECTION
invoke glLoadIdentity
invoke gluPerspective,DWORD PTR Float45,DWORD PTR Float45+4,DWORD PTR Float1,DWORD PTR Float1+4,DWORD PTR Float3,DWORD PTR Float3+4,DWORD PTR Float9,DWORD PTR Float9+4
invoke glMatrixMode,GL_MODELVIEW
invoke glLoadIdentity
ret
ResizeObject ENDP
; #########################################################################
CreateLight    PROC
invoke	glLightfv,GL_LIGHT0,GL_POSITION,ADDR  LightPosition
invoke	glLightfv,GL_LIGHT0,GL_SPECULAR,ADDR  LightPosition
invoke	glLightfv,GL_LIGHT0,GL_AMBIENT_AND_DIFFUSE,ADDR  LightPosition
			invoke	glEnable,GL_LIGHT0


ret
CreateLight    ENDP

; #########################################################################
CreateObjects		PROC	ParentW:DWORD,ParentH:DWORD

invoke Ellipsoide,1,ADDR ObjectRadius,24,24,GL_LINE_LOOP


invoke glMatrixMode,GL_PROJECTION
ret

CreateObjects		ENDP
; #########################################################################

DrawScene PROC 


invoke glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
invoke CreateLight 
invoke glPushMatrix
invoke Rotate,1,ADDR Position1,ADDR RotationAngles,ADDR RotationSpeed 
invoke glPopMatrix

invoke SwapBuffers,MainHDC 
ret
DrawScene ENDP
; #########################################################################
Put2Scene		PROC	ListNumber:DWORD,ZYXPosition:DWORD
			
			mov	eax,ZYXPosition
			invoke	glTranslatef,[eax],[eax+4],[eax+8]

			mov	eax,ZYXPosition
			
			invoke	glRotatef,[eax+12],[eax+16],[eax+20],[eax+24]
	    		
	    		
			invoke	glCallList,ListNumber

			ret
Put2Scene		ENDP
; #########################################################################
Rotate		PROC	ListNumber:DWORD,ZYXPosition:DWORD,ZYXRotations:DWORD,ZYXAngles:DWORD
			
	mov	eax,ZYXPosition
	invoke	glTranslatef,[eax],[eax+4],[eax+8]
mov	eax,ZYXPosition
	invoke	glScalef,[eax+12],[eax+12],[eax+12]
			mov	eax,ZYXAngles			
	    		mov	ebx,ZYXRotations
	    		fld	DWORD PTR [eax+8]
	    		fadd	DWORD PTR [ebx+8]
	    		fstp	DWORD PTR [eax+8]
	    		invoke	glRotatef,DWORD PTR [eax+8],dFloat0,dFloat0,dFloat1
	    		
	    		mov	eax,ZYXAngles			
	    		mov	ebx,ZYXRotations
	    		fld	DWORD PTR [eax+4]
	    		fadd	DWORD PTR [ebx+4]
	    		fstp	DWORD PTR [eax+4]
	    		invoke	glRotatef,[eax+4], dFloat1,dFloat0,dFloat0

			mov	eax,ZYXAngles			
	    		mov	ebx,ZYXRotations
	    		fld	DWORD PTR [eax]
	    		fadd	DWORD PTR [ebx]
	    		fstp	DWORD PTR [eax]
	    		invoke	glRotatef,[eax],dFloat0,dFloat1,dFloat0	 

   		
			invoke	glCallList,ListNumber
			ret

Rotate		ENDP

;#################################################################
Ellipsoide PROC  ListNumber:DWORD,Radius:DWORD,Zparts:DWORD,XYparts:DWORD,FillType:DWORD
LOCAL	phi:DWORD,i:DWORD,j:DWORD
LOCAL	Rx:DWORD,Ry:DWORD,Rz:DWORD
LOCAL	theta:DWORD,theta0:DWORD,theta1:DWORD
LOCAL	phi0:DWORD,sphi0:DWORD,cphi0:DWORD
LOCAL	phi1:DWORD,sphi1:DWORD,cphi1:DWORD
LOCAL	x0:DWORD,y0:DWORD,z0:DWORD,x1:DWORD,y1:DWORD,z1:DWORD,x2:DWORD,y2:DWORD,z2:DWORD,x3:DWORD,y3:DWORD,z3:DWORD	

finit
fldpi
fmul[dva]
fidiv[XYparts]

fst[phi]

fldpi
fmul[dva]
fidiv[Zparts]
fst[theta]



invoke	glNewList,ListNumber,GL_COMPILE_AND_EXECUTE 
	
mov eax,0
mov i,eax

newcicle:
finit
fld[phi]
fimul[i]
fst[phi0]
fcos
fst[cphi0]

finit
fld[phi0]
fsin
fst[sphi0]

mov eax,0
mov j,eax

newline:
finit

fld[theta]
fimul[j]
fst[theta0]


fsin
fmul[cphi0]
mov eax,Radius
fmul DWORD PTR [eax+4]
fst[y0]

finit
fld[theta0]
fcos
fmul[cphi0]
mov eax,Radius
fmul DWORD PTR [eax]
fst[x0]

finit
fld[phi0]
fsin
mov eax,Radius
fmul DWORD PTR [eax+8]
fst[z0]

finit
fld[theta0]
fadd[theta]
fst[theta1]
fsin
fmul[cphi0]
mov eax,Radius
fmul DWORD PTR [eax+4]
fst[y1]

finit
fld[theta1]
fcos
fmul[cphi0]
mov eax,Radius
fmul DWORD PTR [eax]
fst[x1]

fld[phi0]
fsin
mov eax,Radius
fmul DWORD PTR [eax+8]
fst[z1]

fld[phi0]
fadd[phi]
fst[phi1]
fsin
fst[sphi1]
finit
fld[phi1]
fcos
fst[cphi1]



fld[theta1]
fsin
fmul[cphi1]
mov eax,Radius
fmul DWORD PTR [eax+4]
fst[y2]

finit
fld[theta1]
fcos
fmul[cphi1]
mov eax,Radius
fmul DWORD PTR [eax]
fst[x2]

fld[phi1]
fsin
mov eax,Radius
fmul DWORD PTR [eax+8]
fst[z2]

finit
fld[theta0]
fsin
fmul[cphi1]
mov eax,Radius
fmul DWORD PTR [eax+4]
fst[y3]

finit
fld[theta0]
fcos
fmul[cphi1]
mov eax,Radius
fmul DWORD PTR [eax]
fst[x3]

fld[phi1]
fsin
mov eax,Radius
fmul DWORD PTR [eax+8]
fst[z3]


invoke glBegin,FillType


invoke glNormal3f,x0, y0, z0
invoke glVertex3f,x0,y0,z0


invoke glNormal3f,x1, y1, z1
invoke glVertex3f,x1,y1,z1

invoke glNormal3f,x2, y2, z2
invoke glVertex3f,x2,y2,z2


invoke glNormal3f,x3, y3, z3
invoke glVertex3f,x3,y3,z3

invoke glEnd

inc j
mov eax,j
cmp eax,XYparts
jle newline



inc i
mov eax,i
cmp eax,Zparts
jnz newcicle
invoke	glEndList
invoke glDisable,GL_TEXTURE_2D
ret
Ellipsoide	ENDP
; #########################################################################
Init proc hWn:DWORD
LOCAL WINRect:RECT
LOCAL PixFormat:DWORD

invoke GetDC,hWn
mov MainHDC,eax
mov ax,SIZEOF PixFrm
mov PixFrm.nSize,ax
mov PixFrm.nVersion,1
mov PixFrm.dwFlags,PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER
mov PixFrm.dwLayerMask,PFD_MAIN_PLANE
mov PixFrm.iPixelType,PFD_TYPE_RGBA
mov PixFrm.cColorBits,8
mov PixFrm.cDepthBits,16
mov PixFrm.cAccumBits,0
mov PixFrm.cStencilBits,0
invoke ChoosePixelFormat,MainHDC,ADDR PixFrm
mov PixFormat,eax
invoke SetPixelFormat,MainHDC,PixFormat,ADDR PixFrm
or eax,eax
jz Fail
invoke wglCreateContext,MainHDC
mov OpenDC,eax
invoke wglMakeCurrent,MainHDC,OpenDC
invoke GetClientRect,hWn,ADDR WINRect

invoke	CreateObjects,WINRect.right,WINRect.bottom
invoke glEnable,GL_COLOR_MATERIAL
invoke	glEnable,GL_DEPTH_TEST
invoke	glEnable,GL_LIGHTING
invoke	glEnable,GL_NORMALIZE			
jmp abrt
Fail:
invoke MessageBox,hWn,SADD("OpenGL a  "),SADD("  "),MB_OK

abrt:

return 0

Init endp
; ########################################################